/**************************************************************************
 *  Copyright (C) 2008 by Simon Qian                                      *
 *  SimonQian@SimonQian.com                                               *
 *                                                                        *
 *  Project:    vsprog                                                    *
 *  File:       hex.h                                                     *
 *  Author:     SimonQian                                                 *
 *  Versaion:   See changelog                                             *
 *  Purpose:    hex file parser                                           *
 *  License:    See license                                               *
 *------------------------------------------------------------------------*
 *  Change Log:                                                           *
 *      YYYY-MM-DD:     What(by Who)                                      *
 *      2008-10-29:     created(by SimonQian)                             *
 **************************************************************************/
#include "app_cfg.h"

#define HEX_TYPE_DATA				0x00
#define HEX_TYPE_EOF				0x01
#define HEX_TYPE_SEG_ADDR			0x02
#define HEX_TYPE_EXT_ADDR			0x04

typedef RESULT (*HEX_WRITE_MEMORY_LINE_CALLBACK)(uint32, uint32, uint8*, uint32);

RESULT read_hex_file(FILE *hex_file, HEX_WRITE_MEMORY_LINE_CALLBACK callback);
RESULT write_hex_file_line(FILE *hex_file, uint32 data_addr, uint32 seg_addr, uint8 *data, uint8 len);

